select
an.numero,
(case sp.cbasica when 6 then 'Novilha' when 7 then 'Vaca' else null end) as categoria,
(select nome from setor where cdsetor = (select setor from sp_setoranimal(rep.cdanimal, rep.data))) as setor,
rep.data,
tp.descricao as tipo,    
(case when (rep.condicaoia = 'N') then 'Cio natural' when (rep.condicaoia = 'P')
then 'Prostaglandina' when (rep.condicaoia = 'I') then 'Protocolo IATF' else null end) as condicao,
(case when (rep.condicaoia = 'I') then pro.descricao else null end) as protocolo,
emb.numero as numero_embriao,
pes.nome as inseminador,
tou.numero as reprodutor,
maeemb.numero as doadora,
paiemb.numero as pai_emb,
prox.data as data_diagnostico,
(case when (prox.diagnostico='P') then 'P' when (prox.cdtiporeproducao in (1,2,3)) then 'N' when (prox.diagnostico='N') then 'N' when (prox.cio in ('1','2')) then 'N' else null end) as diagnostico,
(case when (prox.diagnostico='P') then '1' when (prox.cdtiporeproducao in (1,2,3)) then '1' when (prox.diagnostico='N') then '1' when (prox.cio in ('1','2')) then '1' else '0' end) as contagem_para_concepcao_com_DG,
(case when (prox.diagnostico='P') then '1' when (prox.cdtiporeproducao in (1,2,3)) then '0' when (prox.diagnostico='N') then '0' when (prox.cio in ('1','2')) then '0' else '0' end) as contagem_para_concepcao_positiva
from
animal an join reproducao rep on an.cdanimal=rep.cdanimal
left join tiporeproducao tp on rep.cdtiporeproducao=tp.cdtiporeproducao
left join reproducao prox on prox.cdreproducao=(select first 1 ref.cdreproducao from reproducao ref where rep.cdanimal=ref.cdanimal and ref.data>rep.data and ((ref.cdtiporeproducao=4 and diagnostico is not null) or (ref.cdtiporeproducao=4 and cio in (1,2)) or (ref.cdtiporeproducao in (1,2,3)))order by ref.data)
left join tiporeproducao tp2 on prox.cdtiporeproducao=tp2.cdtiporeproducao
left join animal tou on rep.cdreprodutor=tou.cdanimal
left join animal emb on rep.cdembriao=emb.cdanimal
left join animal maeemb on emb.cdmae=maeemb.cdanimal
left join animal paiemb on emb.cdpai=paiemb.cdanimal
left join pessoa pes on pes.cdpessoa=rep.cdpessoa
left join setor se on se.cdsetor=an.cdsetor
left join sp_categoriaanimal(rep.data, 'CDANIMAL = ' || rep.cdanimal) sp on sp.animal = rep.cdanimal
left join protocoloiatf pro on pro.cdprotocoloiatf = rep.cdprotocoloiatf
where
rep.cdtiporeproducao in (1,2,3) and
rep.data>='2015-07-01' and
rep.data<='2015-07-31'
order by
an.numero
